package main

import (
	"fmt"
	"os"
	"os/exec"

	"gopkg.in/redis.v5"
)

func printHighScores(redisClient *redis.Client, username string) {
	exec.Command("stty", "-F", "/dev/tty", "echo", "-cbreak").Run()
	clearScreen()

	nh := exec.Command("reclist", "-f", fmt.Sprintf("%s/record", config.NethackLauncher.HackDir), "-n", "10")
	//cmd := fmt.Sprintf("nethack -d %s -s -v |head -31", config.NethackLauncher.HackDir)
	//nh := exec.Command("bash", "-c", cmd)
	nh.Stdout = os.Stdout
	nh.Stdin = os.Stdin
	nh.Stderr = os.Stderr
	nh.Run()

	println("")
	println(" Press enter to return to menu")
	println("")
	fmt.Printf(">> ")

	// allow user back to home screen
	// disable input buffering
	exec.Command("stty", "-F", "/dev/tty", "cbreak", "min", "1").Run()
	// do not display entered characters on the screen
	exec.Command("stty", "-F", "/dev/tty", "-echo").Run()

	var b []byte = make([]byte, 1)
	for {
		os.Stdin.Read(b)

		// check if user is trying to navigate
		if string(b) == "\n" {
			exec.Command("stty", "-F", "/dev/tty", "echo", "-cbreak").Run()
			clearScreen()
			if username == "" {
				printWelcomeScreen(redisClient)
			} else {
				printUserScreen(redisClient, username)
			}
		}
	}
}

func printAllScores(redisClient *redis.Client, username string) {
	exec.Command("stty", "-F", "/dev/tty", "echo", "-cbreak").Run()
	clearScreen()

	nh := exec.Command("nethack", "-d", config.NethackLauncher.HackDir, "-s", "-v")
	nh.Stdout = os.Stdout
	nh.Stdin = os.Stdin
	nh.Stderr = os.Stderr
	nh.Run()

	println("")
	println(" Press enter to return to menu")
	println("")
	fmt.Printf(">> ")

	// allow user back to home screen
	// disable input buffering
	exec.Command("stty", "-F", "/dev/tty", "cbreak", "min", "1").Run()
	// do not display entered characters on the screen
	exec.Command("stty", "-F", "/dev/tty", "-echo").Run()

	var b []byte = make([]byte, 1)
	for {
		os.Stdin.Read(b)

		// check if user is trying to navigate
		if string(b) == "\n" {
			exec.Command("stty", "-F", "/dev/tty", "echo", "-cbreak").Run()
			clearScreen()
			if username == "" {
				printWelcomeScreen(redisClient)
			} else {
				printUserScreen(redisClient, username)
			}
		}
	}
}
