package main

import (
	"fmt"
	"os"
	"os/exec"

	"gopkg.in/redis.v5"
)

func printWelcomeScreen(redisClient *redis.Client) string {
	clearScreen()
	fmt.Printf(" %s\n", config.NethackLauncher.ServerDisplay)
	println(" Not logged in.")
	println("")
	println(" l) Login")
	println(" r) Register new user")
	println(" w) Watch games in progress")
	println(" q) Quit")
	println("")
	fmt.Printf(">> ")

	// disable input buffering
	exec.Command("stty", "-F", "/dev/tty", "cbreak", "min", "1").Run()
	// do not display entered characters on the screen
	exec.Command("stty", "-F", "/dev/tty", "-echo").Run()

	var b []byte = make([]byte, 1)
	for {
		os.Stdin.Read(b)
		switch string(b) {
		case "l":
			// restart display
			exec.Command("stty", "-F", "/dev/tty", "echo", "-cbreak").Run()
			clearScreen()
			printLoginScreen(redisClient)
		case "r":
			// restart display
			exec.Command("stty", "-F", "/dev/tty", "echo", "-cbreak").Run()
			clearScreen()
			printRegisterScreen(redisClient)
		case "w":
			clearScreen()
			printProgressScreen(redisClient, "")
		case "q":
			exec.Command("stty", "-F", "/dev/tty", "echo", "-cbreak").Run()
			clearScreen()
			os.Exit(0)
		default:
		}
	}
}
